/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gps.com.Ejb;

import gps.com.Jpa.Coordonnees;
import gps.com.Jpa.Invitation;
import gps.com.Jpa.Meeting;
import gps.com.Jpa.User;
import java.util.List;
import javax.ejb.Local;

/**
 *
 * @author rado
 */
@Local
public interface UserFacadeLocal {
    
    List<User> findRange(int[] range);
    
    int count();

    void create(User user);
    
    void edit(User user);

    void remove(User user);

    User find(Object id);

    List<User> findAll();
    
    List<User> findUser(String rechercher);
    
    List<User> findUserByMail(String email);
    
    List<User> findUserByPhone(String rechercher);
    
    List<User> findUserBySecretCode(String rechercher);
    

   public void addFriend(User u1,User u2);

   public List<User> Liste_de_tous_les_amis(User u1);

   public List<User> liste_des_amis_dans_groupe(Meeting m,User u);
   
   public void Ajouter_ami(User u1,User u2);
   public void Ajouter_ami_dans_meeting(Meeting m1,User user1,User u2);
     
   public Coordonnees trouver_point_meeting(User u);
     
   public void supprimer_amis(User u, String liste);
        
   public List<Coordonnees> coordonnees_amis(User u);
   
   public List<Coordonnees> coordonnees_membre_rdv(User u);
   
   public List<Meeting> trouver_rdv_par_id(int id_rdv);
   public List<Meeting> trouver_mes_rdv(User u);
  
    public void addCoordonnee(Coordonnees c);   
}
