/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gps.com.Jpa;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Oussama
 */
@Entity
@Table(name = "user")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "User.findAll", query = "SELECT u FROM User u"),
    @NamedQuery(name = "User.findByIdUser", query = "SELECT u FROM User u WHERE u.idUser = :idUser"),
    @NamedQuery(name = "User.findByPhone", query = "SELECT u FROM User u WHERE u.phone = :phone"),
    @NamedQuery(name = "User.findByEmail", query = "SELECT u FROM User u WHERE u.email = :email"),
    @NamedQuery(name = "User.findBySecretCode", query = "SELECT u FROM User u WHERE u.secretCode = :secretCode"),
    @NamedQuery(name = "User.findByGeneratedCode", query = "SELECT u FROM User u WHERE u.generatedCode = :generatedCode"),
    @NamedQuery(name = "User.findByPassword", query = "SELECT u FROM User u WHERE u.password = :password"),
    @NamedQuery(name = "User.findByNom", query = "SELECT u FROM User u WHERE u.nom = :nom"),
    @NamedQuery(name = "User.findByPrenom", query = "SELECT u FROM User u WHERE u.prenom = :prenom"),
    @NamedQuery(name = "User.findByVisibility", query = "SELECT u FROM User u WHERE u.visibility = :visibility"),
    @NamedQuery(name = "User.findByVisibilityMeeting", query = "SELECT u FROM User u WHERE u.visibilityMeeting = :visibilityMeeting"),
    @NamedQuery(name = "User.findByVisibilityFreind", query = "SELECT u FROM User u WHERE u.visibilityFreind = :visibilityFreind"),
    @NamedQuery(name = "User.findByActivate", query = "SELECT u FROM User u WHERE u.activate = :activate"),
    @NamedQuery(name = "User.findByConnecter", query = "SELECT u FROM User u WHERE u.connecter = :connecter")})
public class User implements Serializable {
    @ManyToMany(mappedBy = "userList")
    private List<Meeting> meetingList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "idUserAdmin")
    private List<Meeting> meetingList1;
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "ID_USER")
    private Integer idUser;
    // @Pattern(regexp="^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$", message="Invalid phone/fax format, should be as xxx-xxx-xxxx")//if the field contains phone or fax number consider using this annotation to enforce field validation
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 10)
    @Column(name = "PHONE")
    private String phone;
    // @Pattern(regexp="[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?", message="Invalid email")//if the field contains email address consider using this annotation to enforce field validation
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 100)
    @Column(name = "EMAIL")
    private String email;
    @Size(max = 100)
    @Column(name = "SECRET_CODE")
    private String secretCode;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 100)
    @Column(name = "GENERATED_CODE")
    private String generatedCode;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 100)
    @Column(name = "PASSWORD")
    private String password;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 255)
    @Column(name = "NOM")
    private String nom;
    @Size(max = 255)
    @Column(name = "PRENOM")
    private String prenom;
    @Basic(optional = false)
    @NotNull
    @Column(name = "VISIBILITY")
    private short visibility;
    @Column(name = "VISIBILITY_MEETING")
    private Integer visibilityMeeting;
    @Column(name = "VISIBILITY_FREIND")
    private Integer visibilityFreind;
    @Basic(optional = false)
    @NotNull
    @Column(name = "ACTIVATE")
    private short activate;
    @Column(name = "CONNECTER")
    private Integer connecter;
    @JoinTable(name = "contact", joinColumns = {
        @JoinColumn(name = "ID_USER2", referencedColumnName = "ID_USER")}, inverseJoinColumns = {
        @JoinColumn(name = "ID_USER", referencedColumnName = "ID_USER")})
    @ManyToMany
    private List<User> userList;
    @ManyToMany(mappedBy = "userList")
    
    
    private List<User> userList1;

    public User() {
    }

    public User(Integer idUser) {
        this.idUser = idUser;
    }
    
    public User(User _u) {
       this.idUser = _u.idUser;
        this.phone = _u.phone;
        this.email = _u.email;
        this.generatedCode = _u.generatedCode;
        this.secretCode = _u.secretCode;
        this.password = _u.password;
        this.nom = _u.nom;
        this.prenom = _u.prenom;
        this.visibility = _u.visibility;
        this.activate = _u.activate;
        this.visibilityMeeting = _u.visibilityMeeting;
    }
    

    public User(Integer idUser, String phone, String email, String generatedCode,String secretCode, String password, String nom,String prenom, short visibility, short activate,int visibilityMeeting) {
        this.idUser = idUser;
        this.phone = phone;
        this.email = email;
        this.generatedCode = generatedCode;
        this.secretCode = secretCode;
        this.password = password;
        this.nom = nom;
        this.prenom = prenom;
        this.visibility = visibility;
        this.activate = activate;
        this.visibilityMeeting = visibilityMeeting;
    }
    
        public User(Integer idUser, String phone, String email,String nom,String prenom, short visibility, short activate) {
        this.idUser = idUser;
        this.phone = phone;
        this.email = email;
        this.nom = nom;
        this.prenom = prenom;
        this.visibility = visibility;
        this.activate = activate;
    }
    
        public User(String phone, String email, String generatedCode,String secretCode, String password, String nom,String prenom) {
        this.phone = phone;
        this.email = email;
        this.generatedCode = generatedCode;
        this.secretCode = secretCode;
        this.password = password;
        this.nom = nom;
        this.prenom = prenom;
    }


    public Integer getIdUser() {
        return idUser;
    }

    public void setIdUser(Integer idUser) {
        this.idUser = idUser;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getSecretCode() {
        return secretCode;
    }

    public void setSecretCode(String secretCode) {
        this.secretCode = secretCode;
    }

    public String getGeneratedCode() {
        return generatedCode;
    }

    public void setGeneratedCode(String generatedCode) {
        this.generatedCode = generatedCode;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public String getPrenom() {
        return prenom;
    }

    public void setPrenom(String prenom) {
        this.prenom = prenom;
    }

    public short getVisibility() {
        return visibility;
    }

    public void setVisibility(short visibility) {
        this.visibility = visibility;
    }

    public Integer getVisibilityMeeting() {
        return visibilityMeeting;
    }

    public void setVisibilityMeeting(Integer visibilityMeeting) {
        this.visibilityMeeting = visibilityMeeting;
    }

    public Integer getVisibilityFreind() {
        return visibilityFreind;
    }

    public void setVisibilityFreind(Integer visibilityFreind) {
        this.visibilityFreind = visibilityFreind;
    }

    public short getActivate() {
        return activate;
    }

    public void setActivate(short activate) {
        this.activate = activate;
    }

    public Integer getConnecter() {
        return connecter;
    }

    public void setConnecter(Integer connecter) {
        this.connecter = connecter;
    }

    @XmlTransient
    public List<User> getUserList() {
        return userList;
    }

    public void setUserList(List<User> userList) {
        this.userList = userList;
    }

    @XmlTransient
    public List<User> getUserList1() {
        return userList1;
    }

    public void setUserList1(List<User> userList1) {
        this.userList1 = userList1;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idUser != null ? idUser.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof User)) {
            return false;
        }
        User other = (User) object;
        if ((this.idUser == null && other.idUser != null) || (this.idUser != null && !this.idUser.equals(other.idUser))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gps.com.Jpa.User[ idUser=" + idUser + " ]";
    }

    @XmlTransient
    public List<Meeting> getMeetingList() {
        return meetingList;
    }

    public void setMeetingList(List<Meeting> meetingList) {
        this.meetingList = meetingList;
    }

    @XmlTransient
    public List<Meeting> getMeetingList1() {
        return meetingList1;
    }

    public void setMeetingList1(List<Meeting> meetingList1) {
        this.meetingList1 = meetingList1;
    }
    
}
