/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gps.com.dao;

import gps.com.Ejb.UserFacadeLocal;
import gps.com.Jpa.Coordonnees;
import gps.com.Jpa.Invitation;
import gps.com.Jpa.Meeting;
import gps.com.Jpa.Messagerie;
import gps.com.Jpa.User;
import java.util.List;

/**
 *
 * @author oussama
 */
public interface UserDao extends UserFacadeLocal {

    public void createMeeting(User u, Meeting m);

    public List<User> getFriendByMail(String email);
    public List<User> findUserBySecretCode(String code);

    public List<Meeting> findMeetingByName(String name);

    public void createInvitation(Invitation invit);

    public void stocker_msg(Messagerie msg);

    public List<User> findUserByInvitation(int iduser);

    public List<Invitation> findInvitationByUsers(int iduser1, int iduser2);

    public void updateInvitation(Invitation invit);

    public List<User> findFriendsById(int iduser);

    public void addCoordonnee(Coordonnees c);

    public List<Coordonnees> findCoordonneesByUser(int iduser);
    
    public List<Coordonnees> getUserFriendsWithCoordoonnee(int idUser);

    public List<Coordonnees> findAllCoord();

    public void edit(Coordonnees c);

    public void edit(Meeting m);

    public void deletemeeting(Meeting m);

    public void deleteinvitation(Invitation i);

    public void updateMeeting(Meeting m);

    public List<User> getInvite(int idinvitation);

    public List<Meeting> findMeetingAcceptByuser(int iduser);

    public List<Meeting> findMeetingByid(int id);
    
    public List<Meeting> findMeetingCreatedByuser(int iduser);

    public List<Invitation> findAllFriendGroup(int idmeeting);

    public List<Invitation> findAllFriendGroupNotaccepted(int iduser);

    public List<Invitation> findInvitationByUsersMeeting(int iduser1, int iduser2, int idmeeting);

    public List<Invitation> findInvitationByUser_Meeting(int iduser, int idmeeting);

    public List<Coordonnees> findCoordonneesUserByTime(int iduser);

  
     public void UpdateUser(User user);


        
    
    
}
