/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gps.com.daoImpl;

import gps.com.Jpa.Meeting;
import gps.com.Jpa.User;
import gps.com.dao.MeetingDao;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Stateless(mappedName = "Interface")
@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class MeetingDaoImpl implements MeetingDao {

    @PersistenceContext
    private EntityManager em;
    
    @Override
    public void create(Meeting meet) {
        try {
          em.persist(meet);
        } catch(Throwable th) {
        }  
    }

    @Override
    public void edit(Meeting meet) {
    em.merge(meet);
            }

    @Override
    public void remove(Meeting meet) {
         try {
            em.remove(meet);
        } catch(Throwable th) {
        }      
    }

    @Override
    public Meeting find(Object id) {
        return em.find(Meeting.class, id);
    }
    
    @Override
     public List<Meeting> findMeetingById(String id) {
        return em.createQuery("select m from Meeting m where m.idMeeting='"+id+"'").getResultList();    
    }
     
     
     
    @Override
    public List<User> findUsersInMeeting(String id) {
         return em.createQuery("select u from Meeting m, User u  where u.idUser='"+id+"'").getResultList();  
    }

    @Override
    public List<Meeting> findAll() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public List<Meeting> findRange(int[] range) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public int count() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }


    
     
}
    
