/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gps.com.daoImpl;

import gps.com.Jpa.Coordonnees;
import gps.com.Jpa.Invitation;
import gps.com.Jpa.Meeting;
import gps.com.Jpa.Messagerie;
import gps.com.Jpa.User;
import gps.com.dao.UserDao;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

@Stateless(mappedName = "Interface")
@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class UserDaoImpl implements UserDao {

    @PersistenceContext
    private EntityManager em;
    
    
    @Override
    public void create(User user) {
        try {
          em.persist(user);
        } catch(Throwable th) {
        }  
    }

    @Override
    public void edit(User user) {
        em.merge(user);
    }
    
   @Override
    public void edit(Coordonnees c) {
        em.merge(c);
    }
    
    @Override
    public void edit(Meeting m) {
        em.merge(m);
    }


    @Override
    public void remove(User user) {
         try {
            em.remove(user);
        } catch(Throwable th) {
        }      
    }
    @Override
    public void deletemeeting(Meeting m) {
         try {
            em.remove(m);
        } catch(Throwable th) {
        }      
    }

    @Override 
    public void UpdateUser(User user)
    {
        int val = em.createQuery("UPDATE user SET NOM ='"+user.getNom()+"', " 
              + "PRENOM = '"+ user.getNom()
              + "', PASSWOARD = '"+user.getPassword()
              + "', EMAIL = '"+user.getEmail()
              + "', PHONE = '"+user.getPhone()+"'"      
              + "WHERE ID_USER = "+user.getIdUser()
              ).executeUpdate();        
        System.out.println(val);        
        
    }    
    
    
        @Override
    public void deleteinvitation(Invitation i) {
         try {
            em.remove(i);
        } catch(Throwable th) {
        }      
    }

    @Override
    public User find(Object id) {
        return em.find(User.class, id);
    }

    @Override
    public List<User> findAll() {
        return em.createQuery("select u from User u").getResultList(); 
    }

    @Override
    public List<User> findRange(int[] range) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public int count() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    
    @Override
    public List<User> findUser(String rechercher) {            
        return em.createQuery("select u from User u where u.phone='"+rechercher+"' OR u.email='"+rechercher+"'OR u.nom='"+rechercher+"' OR u.prenom='"+rechercher+"'").getResultList();
    }
    

    @Override
     public List<User> findUserByMail(String rechercher) {
        return em.createQuery("select u from User u where u.email='"+rechercher+"'").getResultList();
    
    }
     
     @Override
     public List<User> findUserBySecretCode(String rechercher) {
        return em.createQuery("select u from User u where u.secret_code = '"+rechercher+"'").getResultList();
    
    }

    @Override
     public List<User> findUserByPhone(String rechercher) {
        return em.createQuery("select u from User u where u.email='"+rechercher+"'").getResultList();    
    }     

    @Override
     public void addFriend(User u1,User u2) {         
        em.flush();    
    }

     
@Override
     public List<User> Liste_de_tous_les_amis(User u1) {
         List<User> listuser = new ArrayList<>();
        // Query query = em.createNativeQuery("select distinct id_User2 from contact c where c.id_user = "+u1.getIdUser());
          Query query = em.createNativeQuery("select * FROM user WHERE id_user in (select distinct id_User2 from contact where id_user = "+u1.getIdUser()+")");
       
          List<Object> resultList = query.getResultList();
          
    
         for (Object result : resultList)
         { 
            Object[] r = (Object[]) result; 
            if(r.length!=13) continue;
           
            int idUser = Integer.parseInt(r[0].toString());
            String phone =r[1].toString();
            String email =r[2].toString();
            String nom = r[6].toString();
            String prenom = r[7].toString();
            short visibility = (short)Integer.parseInt(r[8].toString());
            short activate =(short)Integer.parseInt(r[11].toString());
           
            User u = new User( idUser,  phone,  email, nom, prenom,  visibility,  activate);
            listuser.add(u);
     
        } 
        return listuser;
          
    }      
     
     // public void supprimer_amis(User u, String liste);
     
     @Override
     public void supprimer_amis(User u, String liste) {
               
         String requete= "delete from contact where id_user = " +u.getIdUser()+" and id_user2 in ("+liste+")";
         em.createNativeQuery(requete).executeUpdate();
         
         //supprimer dans l'ature sens
         String requete2= "delete from contact where id_user2 = " +u.getIdUser()+" and id_user in ("+liste+")";
         em.createNativeQuery(requete2).executeUpdate();
    } 
     
     @Override
     public List<Meeting> trouver_mes_rdv(User u)
     {
         List<Meeting> listMe = new ArrayList<Meeting>();
         
         //Query query = em.createNativeQuery("SELECT m.* , u.* FROM meeting m,user u WHERE m.id_user_admin = u.id_user AND (m.id_meeting IN ( SELECT distinct id_meeting FROM user_meeting WHERE id_user = "+u.getIdUser()+") OR m.id_user_admin = " +u.getIdUser()+")");
         Query query = em.createNativeQuery("SELECT m.*  FROM meeting m WHERE m.id_meeting IN ( SELECT distinct id_meeting FROM user_meeting WHERE id_user = "+u.getIdUser()+") OR m.id_user_admin = " +u.getIdUser());
        
         List<Object> resultList = query.getResultList(); //BUG?
         
         for (Object result : resultList)
         { 
            Object[] r = (Object[]) result; 
            
            Date d = null; //new Date(r[3].toString());
            try {
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd HH:mm:ss");
                ParsePosition pos = new ParsePosition(0);
                d = formatter.parse(r[5].toString(),pos);
            } catch (RuntimeException e) 
            {
                e.printStackTrace();
            }
           
            String nameMeeting = r[2].toString();
            String xCoord= r[3].toString();
            String yCoord= r[4].toString();
            
            //info user
           int idMeeting = Integer.parseInt(r[0].toString());
           /*
            int idUser = Integer.parseInt(r[6].toString());
            String phone =r[7].toString();
            String email =r[8].toString();
            String nom = (r[12]!=null)?r[12].toString():"";
            String prenom =(r[13]!=null)?r[13].toString():"";
            short visibility = (short)Integer.parseInt(r[14].toString());
            short activate =(short)Integer.parseInt(r[17].toString());
           
            User u2 = new User( idUser,  phone,  email, nom, prenom,  visibility,  activate);
            */    
           User u2 = new User(u.getIdUser(),  u.getPhone(),  u.getEmail(),  u.getNom(),u.getPrenom(),  u.getVisibility(), u.getActivate());
           u2.setVisibilityMeeting(u.getVisibilityMeeting());
          
           Meeting m = new Meeting(idMeeting,u2,nameMeeting, xCoord, yCoord,d);
            listMe.add(m);
         }
          
         return listMe;
     
     }
     
     @Override
     public List<Meeting> trouver_rdv_par_id(int id_rdv) 
     {
         List<Meeting> listMe = new ArrayList<Meeting>();
         Query query = em.createNativeQuery("SELECT m.*, u.* FROM meeting m, user u WHERE m.id_user_admin = u.id_user AND id_meeting = "+id_rdv);
       
          List<Object> resultList = query.getResultList();
           
         for (Object result : resultList)
         { 
            Object[] r = (Object[]) result; 
            
            Date d = null; //new Date(r[3].toString());
            try {
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd HH:mm:ss");
                ParsePosition pos = new ParsePosition(0);
                d = formatter.parse(r[5].toString(),pos);
            } catch (RuntimeException e) 
            {
                e.printStackTrace();
            }
           
            String nameMeeting = r[2].toString();
            String xCoord= r[3].toString();
            String yCoord= r[4].toString();
            
            //info user
           int idMeeting = Integer.parseInt(r[0].toString());
     
            int idUser = Integer.parseInt(r[6].toString());
            String phone =r[7].toString();
            String email =r[8].toString();
            String nom = (r[13]!=null)?r[12].toString():"";
            String prenom =(r[13]!=null)?r[13].toString():"";
            short visibility = (short)Integer.parseInt(r[14].toString());
            short activate =(short)Integer.parseInt(r[17].toString());
           
            User u2 = new User( idUser,  phone,  email, nom, prenom,  visibility,  activate);
            
            Meeting m = new Meeting(idMeeting,u2,nameMeeting, xCoord, yCoord,d);
            listMe.add(m);
         }
         return listMe;
     }
             
     @Override
     public List<Coordonnees> coordonnees_membre_rdv(User u) {
               
         List<Coordonnees> listCo = new ArrayList<>();
         Query query = em.createNativeQuery("SELECT c.id_coord, c.x_coord,c.y_coord,c.time,c.id_user,u.* FROM coordonnees c, user u WHERE c.id_user= u.id_user  and  u.id_user in (select distinct id_User from user_meeting WHERE id_meeting in (SELECT visibility_meeting FROM user where id_user = "+u.getIdUser()+" ))");
       
          List<Object> resultList = query.getResultList();
           
         for (Object result : resultList)
         { 
            Object[] r = (Object[]) result; 
             
            
            int idCoord = Integer.parseInt(r[0].toString());
            Date d = null; //new Date(r[3].toString());
            try {
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd HH:mm:ss");
                ParsePosition pos = new ParsePosition(0);
                d = formatter.parse(r[3].toString(),pos);
            } catch (RuntimeException e) 
            {
                e.printStackTrace();
            }
           
           int idUser = Integer.parseInt(r[5].toString());
            String phone =r[6].toString();
            String email =r[7].toString();
            String nom = r[11].toString();
            String prenom = r[12].toString();
            short visibility = (short)Integer.parseInt(r[13].toString());
            short activate =(short)Integer.parseInt(r[16].toString());
           
            User u2 = new User( idUser,  phone,  email, nom, prenom,  visibility,  activate);
            Coordonnees c = new Coordonnees(idCoord,r[1].toString(),r[2].toString(),d,u2);
            
            listCo.add(c); 
        } 
         return listCo;
    } 
     
    
      @Override
     public Coordonnees trouver_point_meeting(User u) {
               
         Coordonnees Co = new Coordonnees();
         Query query = em.createNativeQuery("SELECT * FROM meeting WHERE  id_meeting = (SELECT visibility_meeting FROM user where id_user = "+u.getIdUser()+" )");
       
         List<Object> resultList = query.getResultList();
           
         for (Object result : resultList)
         { 
            Object[] r = (Object[]) result; 
             
            
            int idCoord = 1;
            Date d = null; //new Date(r[3].toString());
            try {
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd HH:mm:ss");
                ParsePosition pos = new ParsePosition(0);
                d = formatter.parse(r[5].toString(),pos);
            } catch (RuntimeException e) 
            {
                e.printStackTrace();
            }
            
           return new Coordonnees(idCoord,r[3].toString(),r[4].toString(),d,u);
            
        } 
         return new Coordonnees();
    } 
     
     
     @Override
     public List<Coordonnees> coordonnees_amis(User u) {
               
         List<Coordonnees> listCo = new ArrayList<>();
         Query query = em.createNativeQuery("SELECT c.id_coord, c.x_coord,c.y_coord,c.time,c.id_user,u.* FROM coordonnees c, user u WHERE c.id_user= u.id_user  and  u.id_user in (select distinct id_User2 from contact where id_user = "+u.getIdUser()+")");
       
          List<Object> resultList = query.getResultList();
           
         for (Object result : resultList)
         { 
            Object[] r = (Object[]) result; 
             
            
            int idCoord = Integer.parseInt(r[0].toString());
            Date d = null; //new Date(r[3].toString());
            try {
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd HH:mm:ss");
                ParsePosition pos = new ParsePosition(0);
                d = formatter.parse(r[3].toString(),pos);
            } catch (RuntimeException e) 
            {
                e.printStackTrace();
            }
           
           int idUser = Integer.parseInt(r[5].toString());
            String phone =r[6].toString();
            String email =r[7].toString();
            String nom = r[11].toString();
            String prenom = r[12].toString();
            short visibility = (short)Integer.parseInt(r[13].toString());
            short activate =(short)Integer.parseInt(r[16].toString());
           
            User u2 = new User( idUser,  phone,  email, nom, prenom,  visibility,  activate);
            Coordonnees c = new Coordonnees(idCoord,r[1].toString(),r[2].toString(),d,u2);
            
            listCo.add(c); 
        } 
         return listCo;
    } 
     
     
   // @Override
     //-- supprimer le 14/04/2014
     public List<User> Liste_de_tous_les_amis_ancienne(User u1) {
         
         Query query = em.createNativeQuery("select distinct idUser from contact c where c.id_user = "+u1.getIdUser());
         
         List<Object[]> results =query.getResultList(); 
         
         return em.createQuery("select u from User u where u.id_user IN ('44','45')").getResultList();    
    }     
        //return em.createQuery("select u from User u, Contact C where (u.id_user = C.id_user) and (C.id_user="+u1.getIdUser()+")").getResultList();    
            
     
     @Override
     public void Ajouter_ami_dans_meeting(Meeting m1,User u1,User u2) 
     {   
           em.createNativeQuery("update user set  visibility_meeting = "+ m1.getIdMeeting() +" WHERE id_user = "+u2.getIdUser()).executeUpdate();
    
           em.createNativeQuery("insert into user_meeting(id_user, id_meeting) value ("+u2.getIdUser() +","+m1.getIdMeeting()+ ")").executeUpdate();
     }
   
      @Override
     public List<User> liste_des_amis_dans_groupe(Meeting m,User u) {   
         
        List<User> listuser = new ArrayList<>();
        
        Query query = em.createNativeQuery("select * FROM user WHERE id_user in (select distinct id_User from user_meeting where id_meeting = "+m.getIdMeeting()+")");
       
          List<Object> resultList = query.getResultList();
          
    
         for (Object result : resultList)
         { 
            Object[] r = (Object[]) result; 
            if(r.length!=13) continue;
           
            int idUser = Integer.parseInt(r[0].toString());
            String phone =r[1].toString();
            String email =r[2].toString();
            String nom = r[6].toString();
            String prenom = r[7].toString();
            short visibility = (short)Integer.parseInt(r[8].toString());
            short activate =(short)Integer.parseInt(r[11].toString());
           
            User u1 = new User( idUser,  phone,  email, nom, prenom,  visibility,  activate);
            listuser.add(u1); 
        } 
        return listuser;
     }
     
    @Override
     public void Ajouter_ami(User u1,User u2) {   
         
        //em.merge(u2)
        //em.createQuery("insert into contact (id_user, id_user2) value ("+u2.getIdUser() +","+u1.getIdUser() + "),("+u1.getIdUser() +","+u2.getIdUser() + ")").getResultList();   
   
            Query query = em.createNativeQuery("insert into contact (id_user, id_user2) value ("+u2.getIdUser() +","+u1.getIdUser() + "),("+u1.getIdUser() +","+u2.getIdUser() + ")");
            query.executeUpdate();
     }     
     
   
    /**
     *
     * @param u
     * @param m
     */
    @Override
     public void createMeeting(User u,Meeting m) {
        em.persist(m);
        em.flush();    
    }
     
    /**
     *
     * @param invit
     */
    @Override
        public void createInvitation(Invitation invit) {
        em.persist(invit);
        em.flush();    
    }

    /**
     *
     * @param msg
     */
    @Override
        public void stocker_msg(Messagerie msg) {
        em.persist(msg);
        em.flush();    
    }

    /**
     *
     * @param invit
     */
    @Override
    public void updateInvitation(Invitation invit) {
        em.merge(invit);
    } 
      @Override
    public void updateMeeting(Meeting m) {
        em.merge(m);
    } 
        
    
      @Override
     public List<Meeting> findMeetingByName(String rechercher) {
        return em.createQuery("select m from Meeting m where m.nameMeeting='"+rechercher+"'").getResultList();
     }

    /**
     *
     * @param iduser
     * @return
     */
    @Override
     public List<User> findUserByInvitation(int iduser) {
        return em.createQuery("select u from User u,Invitation i WHERE i.ami = 0 AND u.idUser = i.idUser.idUser AND i.idUser2.idUser ='"+iduser+"'").getResultList();
     }

      @Override
     public List<User> getInvite(int idinvitation) {
        return em.createQuery("select u from User u,Invitation i WHERE u.idUser = i.idUser2.idUser AND i.idInvitation ='"+idinvitation+"'").getResultList();
     }
     
     
    /**
     *
     * @param iduser1
     * @param iduser2
     * @return
     */
    @Override
     public List<Invitation> findInvitationByUsers(int iduser1,int iduser2) {
           return em.createQuery("select i from Invitation i WHERE i.idUser.idUser = '"+iduser1+"' "
                   + "AND i.idUser2.idUser ='"+iduser2+"'").getResultList();
     }

    /**
     *
     * @param iduser
     * @return
     */
    @Override
     public List<User> findFriendsById(int iduser) {
            return em.createQuery("select u from User u,Invitation i WHERE i.ami = 1 "
                    + "AND u.idUser = i.idUser.idUser AND ( i.idUser2.idUser ='"+iduser+"' OR i.idUser.idUser ='"+iduser+"') ").getResultList();
     }

     @Override
     public List<Meeting> findMeetingAcceptByuser(int iduser) {
            return em.createQuery("select distinct i.idMeeting from User u,Invitation i WHERE i.ami = 1 "
                    + "AND i.idUser2.idUser ='"+iduser+"' ").getResultList();
     }
     
   
     @Override
     public List<Meeting> findMeetingByid(int id) {
             return em.createQuery("select m from Meeting m WHERE m.id_meeting ='"+id+"' ").getResultList();
     }
     
     @Override
     public List<Meeting> findMeetingCreatedByuser(int iduser) {
         return em.createQuery("select m from Meeting m WHERE m.idUserAdmin.idUser ='"+iduser+"' ").getResultList();
     }
     
      /**
     *
     * @param idmeeting
     * @return
     */
    @Override
     public List<Invitation> findAllFriendGroup(int idmeeting) {
            return em.createQuery("select i from Invitation i WHERE i.idMeeting.idMeeting = '"+idmeeting+"' And i.ami = 1 ").getResultList();
      }

     
    /**
     *
     * @param iduser
     * @return
     */
    @Override
     public List<Invitation> findAllFriendGroupNotaccepted(int iduser) {
            return em.createQuery("select i.idMeeting from Invitation i WHERE i.idUser2.idUser = '"+iduser+"' AND i.ami = 0").getResultList();
      }
     
     
    /**
     *
     * @param iduser
     * @return
     */
    @Override
     public List<Coordonnees> findCoordonneesByUser(int iduser) {
        return em.createQuery("select c from Coordonnees c WHERE c.idUser.idUser = '"+iduser+"'").getResultList();
     }
     
      /**
     *
     * @param iduser
     * @return
     */
    @Override
     public List<Coordonnees> findCoordonneesUserByTime(int iduser) {
        return em.createQuery("select c from Coordonnees c WHERE c.idUser.idUser = '"+iduser+"' ORDER By c.time DESC").getResultList();
     }
     
     @Override
     public List<Coordonnees> getUserFriendsWithCoordoonnee(int idUser) {
        return em.createQuery("SELECT * FROM  Coordonnees c, User u WHERE c.idUser IN u.userList.idUser").getResultList();         
     }
     
     @Override
     public List<Coordonnees> findAllCoord() {
        return em.createQuery("select c from Coordonnees c").getResultList();
     }

    
    @Override
    public void addCoordonnee(Coordonnees c) {
        em.persist(c);
    } 
       

    @Override
    public List<User> getFriendByMail(String email) {
       User u = findUserByMail(email).get(0);
       return u.getUserList1();         
   } 

     /**
     *
     * @param iduser1
     * @param iduser2
     * @param idmeeting
     * @return
     */
    @Override
     public List<Invitation> findInvitationByUsersMeeting(int iduser1,int iduser2,int idmeeting) {
           return em.createQuery("select i from Invitation i WHERE i.idUser.idUser = '"+iduser1+"' "
                   + "AND i.ami = 1 AND i.idMeeting.idMeeting = '"+idmeeting+"' AND i.idUser2.idUser ='"+iduser2+"'").getResultList();
     }

    
     @Override
     public List<Invitation> findInvitationByUser_Meeting(int iduser,int idmeeting) {
           return em.createQuery("select i from Invitation i WHERE i.ami = 0 "
                   + "AND i.idMeeting.idMeeting = '"+idmeeting+"' AND i.idUser2.idUser ='"+iduser+"'").getResultList();
     }

}
    
